<#ftl strip_whitespace=true />
<#--
  Copyright 2008 jpp Development Team
 
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at
 
      http://www.apache.org/licenses/LICENSE-2.0
 
  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
-->
<#import "lib/type.ftl" as TYPE />
<#import "lib/method.ftl" as METHOD />

<@TYPE.PACKAGE model/>

<@TYPE.CLASS model/>
{
    private ${model.spec.qualifiedName} _impl;

    public ${model.target.name.simpleBaseName}()
    {
        _impl = new${model.spec.simpleBaseName}();
    }

<#if model.factory || model.impl??>
    protected ${model.spec.qualifiedName} new${model.spec.simpleBaseName}()
    {
        return
<#if model.impl?? >
        new ${model.impl}(<#if model.reference>this</#if>);
<#elseif model.factory>
        ${model.spec.simpleName}Factory.newInstance().new${model.spec.simpleName}(<#if model.reference>this</#if>);
<#else>
        ServiceLoader.load(${model.spec.qualifiedName}.class).next();
</#if>
    }
<#else>
    protected abstract ${model.spec.qualifiedName} new${model.spec.simpleBaseName}();
</#if>


<#list model.methods as method>
<@METHOD.SIGNATURE method/>
    {
        <#if method.returnType.simpleName != "void">return </#if> <@METHOD.CALL method _impl/>;
    }
</#list>
}
