<#ftl strip_whitespace=true />
<#--
  Copyright 2008 jpp Development Team
 
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at
 
      http://www.apache.org/licenses/LICENSE-2.0
 
  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
-->
<#import "lib/type.ftl" as TYPE />
<#import "lib/method.ftl" as METHOD />
<#import "lib/field.ftl" as FIELD />
<#t>
<@TYPE.PACKAGE model/>

<@TYPE.CLASS model/>
{
<#if model.hasBoundProperty || model.hasConstrainedProperty >
<#t>
  <#if ! model.addPropertyChangeListenerMethod.inherited || ! model.removePropertyChangeListenerMethod.inherited  >
<#t>
    <#if ! model.propertyChangeSupport.inherited>
        <@FIELD.DECLARE field=model.propertyChangeSupport reference="this"/><#t>
    </#if>

    <@METHOD.SIGNATURE model.addPropertyChangeListenerMethod/>
    {
        ${model.propertyChangeSupport.name}.<@METHOD.CALL model.addPropertyChangeListenerMethod />;
    }

    <@METHOD.SIGNATURE model.removePropertyChangeListenerMethod/>
    {
        ${model.propertyChangeSupport.name}.<@METHOD.CALL model.removePropertyChangeListenerMethod />;
    }

  </#if>
<#t>
<#if model.hasConstrainedProperty>
<#t>
  <#if ! model.addVetoableChangeListenerMethod.inherited || ! model.removeVetoableChangeListenerMethod.inherited  >
<#t>
    <#if ! model.vetoableChangeSupport.inherited>
      <@FIELD.DECLARE field=model.vetoableChangeSupport reference="this"/><#t>
    </#if>

    <@METHOD.SIGNATURE model.addVetoableChangeListenerMethod/>
    {
        ${model.vetoableChangeSupport.name}.<@METHOD.CALL model.addVetoableChangeListenerMethod />;
    }

    <@METHOD.SIGNATURE model.removeVetoableChangeListenerMethod/>
    {
        ${model.vetoableChangeSupport.name}.<@METHOD.CALL model.removeVetoableChangeListenerMethod />;
    }

  </#if>
<#t>
</#if>
</#if>
<#t>
<#list model.properties as property>
<#t>
    public static final String ${property.nameConstant} = "${property.name}";

    <@FIELD.DECLARE property.field/>

    <@METHOD.SIGNATURE property.readMethod/>
    {
        <#if model.threaded>synchronized(this) {</#if>
        return ${property.field.name};
        <#if model.threaded>}</#if>
    }

    <@METHOD.SIGNATURE property.writeMethod/>
    {
<#if property.bound || property.constrained>
         ${property.type.qualifiedName} old;

         <#if model.threaded>synchronized(this) {</#if>
         old = ${property.field.name};
  <#if property.constrained>
         ${model.vetoableChangeSupport.name}.fireVetoableChange(${property.nameConstant}, old, ${property.field.name});
  </#if>
         ${property.field.name} = arg_0;
         <#if model.threaded>}</#if>

         ${model.propertyChangeSupport.name}.firePropertyChange(${property.nameConstant}, old, ${property.field.name});
<#else>
        <#if model.threaded>synchronized(this) {</#if>
        ${property.field.name} = arg_0;
        <#if model.threaded>}</#if>
</#if>
    }

</#list>
<#if model.eventSets?size != 0 >
    <@FIELD.DECLARE model.listenerList />

  <#if ! model.exceptionHandler.inherited>
    <@METHOD.SIGNATURE model.exceptionHandler/>
    {
        arg_0.printStackTrace();
    }

  </#if>
</#if>
<#t>
<#list model.eventSets as eventSet>
<#t>
    <@METHOD.SIGNATURE eventSet.addListenerMethod/>
    {
<#if eventSet.unicast>
        if ( ${model.listenerList.name}.getListenerCount(${eventSet.listener.qualifiedBaseName}.class) > 0 )
        {
            throw new java.util.TooManyListenersException();
        }
</#if>
        ${model.listenerList.name}.add(${eventSet.listener.qualifiedBaseName}.class,arg_0);
    }

    <@METHOD.SIGNATURE eventSet.removeListenerMethod/>
    {
        ${model.listenerList.name}.remove(${eventSet.listener.qualifiedBaseName}.class,arg_0);
    }

<#list eventSet.fireEventMethods as fireEventMethod>
    <@METHOD.SIGNATURE fireEventMethod/>
    {
        ${eventSet.listener.qualifiedBaseName}[] all = ${model.listenerList.name}.getListeners(${eventSet.listener.qualifiedBaseName}.class);
        for(${eventSet.listener.qualifiedBaseName} listener: all)
        {
<#if eventSet.listenerMethods[fireEventMethod_index].exceptionTypes?? && eventSet.listenerMethods[fireEventMethod_index].exceptionTypes?size != 0>
            try {
</#if>
            listener.<@METHOD.CALL eventSet.listenerMethods[fireEventMethod_index] />;
<#if eventSet.listenerMethods[fireEventMethod_index].exceptionTypes?? && eventSet.listenerMethods[fireEventMethod_index].exceptionTypes?size != 0>
            }
  <#list eventSet.listenerMethods[fireEventMethod_index].exceptionTypes as exception>
            catch(${exception.qualifiedName} x)
            {
                ${model.exceptionHandler.name}(x);
            }
  </#list>
</#if>
        }
    }

</#list>
</#list>
}
