<#ftl strip_whitespace=true />
<#--
  Copyright 2008 jpp Development Team
 
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at
 
      http://www.apache.org/licenses/LICENSE-2.0
 
  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
-->
<#import "lib/type.ftl" as TYPE />

<@TYPE.PACKAGE model/>

import java.util.ServiceLoader;
import java.util.Iterator;
<#if model.init??>
import java.lang.reflect.Method;
</#if>

public <#if ! model.concrete>abstract</#if> class ${model.target.name.simpleName}
{
    private static final ServiceLoader<${model.target.name.qualifiedName}> _factoryLoader = ServiceLoader.load(${model.target.name.qualifiedName}.class);
<#if model.concrete>
    private static final ServiceLoader<${model.spec.qualifiedName}> _instanceLoader = ServiceLoader.load(${model.spec.qualifiedName}.class);
</#if>

    public static ${model.target.name.qualifiedName} newInstance()
    {
<#if model.concrete>
        Iterator<${model.target.name.qualifiedName}> iterator = _factoryLoader.iterator();
        return iterator.hasNext() ? iterator.next() : new ${model.target.name.simpleName}();
<#else>
        return _factoryLoader.iterator().next();
</#if>
    }

<#if model.concrete>
    public ${model.spec.qualifiedName} new${model.spec.simpleName}()
    {
        ${model.spec.qualifiedName} instance = _instanceLoader.iterator().next();
<#if model.init??>
        initInstance(instance);
</#if>
        return instance;
    }
<#if model.init??>
    protected void initInstance(${model.spec.qualifiedName} instance)
    {
<#if model.init.modifiers.public>
        instance.${model.init.name}();
<#else>
        try
        {
            Method method = ${model.spec.qualifiedName}.class.getDeclaredMethod("${model.init.name}");
            boolean accessible = method.isAccessible();
            method.setAccessible(true);
            method.invoke(instance);
            method.setAccessible(accessible);
        }
        catch (Exception x)
        {
            throw new IllegalStateException(x);
        }
</#if>
    }
</#if>


<#else>
    public abstract ${model.spec.qualifiedName} new${model.spec.simpleName}();
</#if>
}
