<#ftl strip_whitespace=true />
<#--
  Copyright 2008 jpp Development Team
 
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at
 
      http://www.apache.org/licenses/LICENSE-2.0
 
  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
-->
<#import "lib/type.ftl" as TYPE />

<@TYPE.PACKAGE model/>

import java.util.ServiceLoader;
import java.util.Iterator;
<#if model.init??>
import java.lang.reflect.Method;
</#if>

<@TYPE.CLASS model/>
{
    private static ${model.target.name.simpleName} _instance;
<#if model.lazy>
    private static void initInstance()
<#else>
    static
</#if>
    {
<#if model.loader>
        _instance = ServiceLoader.load(${model.target.name.simpleName}.class).iterator().next();
<#else>
        _instance = new ${model.target.name.simpleName}();
</#if>
<#if model.init??>
<#if model.init.modifiers.public || model.init.modifiers.protected >
        _instance.${model.init.name}();
<#else>
        try
        {
            Method method = ${model.spec.qualifiedName}.class.getDeclaredMethod("${model.init.name}");
            boolean accessible = method.isAccessible();
            method.setAccessible(true);
            method.invoke(instance);
            method.setAccessible(accessible);
        }
        catch (Exception x)
        {
            throw new IllegalStateException(x);
        }
</#if>
</#if>
    }

    public static <#if model.lazy && model.threaded>synchronized</#if> ${model.target.name.simpleName} getInstance()
    {
<#if model.lazy>
        if ( _instance == null )
        {
            initInstance();
        }
</#if>
        return _instance;
    }
}

